#
module RBC
  unless file_loaded?(__FILE__)

    def self.compare_lib(*version)
      self.compare_version(version, RBC_VERSION_)
    end

    # @since 2.0.0
    def self.compare_version(v1, v2)
      if v1[0] && v2[0] && v1[0] >= v2[0]
        return true
      end
      if v1[1] && v2[1] && v1[1] >= v2[1]
        return true
      end
      if v1[2] && v2[2] && v1[2] >= v2[2]
        return true
      end
      false
    end

    # @since 2.0.0
    def self.check_lib(*version)
      return false if @lib_update
      return false if version.empty?
      update = false
      unless defined?(RBC::RBC_EXTENSION)
        begin
          # require RBC library.
          require 'RBC_Library_load.rb'
        rescue LoadError => e
          update = true
        end
      end
      if defined?(RBC_VERSION_) && !self.compare_version(version, RBC_VERSION_)
        update = true
      end
      if update
        title = "More than #{version.join('.')} versions of RBC must be installed!(必须安装使用 #{version.join('.')} 版本以上的RBC LIbrary!)"
        if Sketchup.is_online
          @lib_update = UI::WebDialog.new(title)
          @lib_update.set_size( 800, 600 )
          @lib_update.set_url( 'http://www.rbc321.cn/home/plugin/plugindetail/id/225'  )
          if RUBY_PLATFORM =~ /mswin|mingw/i
            @lib_update.show
          else
            @lib_update.show_modal
          end
        else
          UI.messagebox(title)
        end
      end
      !update
    end

  end# unless
end# module RBC
